/*!
 * GxSignaturePad v1.0.0
 * License: Apache License 2.0
 * Copyright 2015 (C) ITcowork Inc. All Rights Reserved.
 * http://itcowork.co.jp/genexus/gxsigpad/
 */
function GxSignaturePad($)
{
	this.PenWidth;
	this.PenColor;
	this.PenCap;
	this.LineWidth;
	this.LineColor;
	this.LineMargin;
	this.LineTop;
	this.Width;
	this.Height;
	this.Base64String;
	this.FullScreen;
	this.BgColor;
	this.TAG;

	this.show = function()
	{
		///UserCodeRegionStart:[show] (do not remove this comment.)
		
		var mythis = this;
		// var control = gx.dom.el(this.AttachedControl);
		
		// First only...
		if(mythis.First){
			mythis.First = false;
		
			var $canvas;

			var options = {
				drawOnly: true,
				defaultAction: 'drawIt',
				validateFields: false,
				bgColour: mythis.BgColor.Html,
				lineWidth: mythis.LineWidth,
				lineColour: mythis.LineColor.Html,
				lineMargin: mythis.LineMargin,
				lineTop: mythis.LineTop,
				output: null,
				sigNav: null,
				name: null,
				typed: null,
				typeIt: null,
				drawIt: null,
				typeItDesc: null,
				drawItDesc: null,
				penWidth: mythis.PenWidth,
				penColour: mythis.PenColor.Html,
				penCap: mythis.PenCap
			};
			
			onResize = function(event) {
				if(mythis.FullScreen){
					$canvas.attr({height:window.innerHeight, width:window.innerWidth});
				}else{
					$canvas.attr({height:mythis.Height, width:mythis.Width});
				}
			};

			/*$(document).ready(function() {

				// Canvas Set.
				$canvas = $('canvas');
				// window.addEventListener('orientationchange', onResize, true);
				// window.addEventListener('resize', onResize, true);

				// Resize Run.
				onResize();

				// Option Set.
				// $('form').signaturePad(options);
				api = $('form').signaturePad(options);
			});*/

			gx.evt.attach(window, 'load', function() {

				// Canvas Set.
				$canvas = $('canvas');
				// window.addEventListener('orientationchange', onResize, true);
				// window.addEventListener('resize', onResize, true);

				// Resize Run.
				onResize();

				// Option Set.
				// $('form').signaturePad(options);
				api = $('form').signaturePad(options);
			});
			
			var html = ''
			html += '<canvas class="pad" width='+ mythis.Width +' height='+ mythis.Height +'></canvas>';
		
			mythis.setHtml(html);
			
		}

		
		///UserCodeRegionEnd: (do not remove this comment.)
	}
	///UserCodeRegionStart:[User Functions] (do not remove this comment.)


	this.First = true;
	this.api;
	
	this.onAlert = function(msg)
	{
		window.alert(msg);
	}
	
	this.clearCanvas = function()
	{
		api.clearCanvas();
	}
	
	this.updateOptions = function()
	{
		var sig = api.getSignatureString();
		var options = {
			drawOnly: true,
			defaultAction: 'drawIt',
			validateFields: false,
			bgColour: this.BgColor.Html,
			lineWidth: this.LineWidth,
			lineColour: this.LineColor.Html,
			lineMargin: this.LineMargin,
			lineTop: this.LineTop,
			output: null,
			sigNav: null,
			name: null,
			typed: null,
			typeIt: null,
			drawIt: null,
			typeItDesc: null,
			drawItDesc: null,
			penWidth: this.PenWidth,
			penColour: this.PenColor.Html,
			penCap: this.PenCap
		};
		api = $('form').signaturePad(options);
		api.regenerate(sig);
	}
	
	this.getBase64 = function(pTag)
	{
		this.TAG = pTag;
		var base64 = api.getSignatureImage();
		this.Base64String = base64.replace(/^.*,/, '');

		// Server Event Call...
		this.Base64Result();
	}

	
	///UserCodeRegionEnd: (do not remove this comment.):
}
